<template>
  <section class="player" v-if="state.activeTrack">
    <section class="player__inner">
      <div class="player__left">
        <section class="player__artist">
          <section class="player__artist__inner">
            <section class="player__artist__picture" v-if="state.activeTrack.artist.picture" v-bind:style="{ backgroundImage: 'url(' + state.activeTrack.artist.picture + ')' }"></section>
          </section>
          <section class="player__artist__meta">
            <section class="player__artist__title">{{state.activeTrack.title}}</section>
            <section class="player__artist__name" @click="onClickArtist">{{state.activeTrack.artist.name}}</section>
          </section>
        </section>
      </div>
      <div class="player__controls">
        <section class="player__control" @click="toggleShuffleMode()" v-bind:class="{ active: state.shuffleMode }">
          <md-tooltip md-direction="top">Shuffle</md-tooltip>
          <md-icon>shuffle</md-icon>
        </section>
        <section class="player__control" @click="playPrev()">
          <md-tooltip md-direction="top">Previous</md-tooltip>
          <md-icon>skip_previous</md-icon>
        </section>
        <section class="player__control" @click="play()">
          <md-tooltip md-direction="top">Play/Pause</md-tooltip>
          <md-icon class="mdPlayIcon" v-if="state.isPlaying">pause</md-icon>
          <md-icon class="mdPlayIcon" v-if="!state.isPlaying">play_arrow</md-icon>
        </section>
        <section class="player__control" @click="playNext()">
          <md-tooltip md-direction="top">Next</md-tooltip>
          <md-icon>skip_next</md-icon>
        </section>
        <section class="player__control" @click="toogleRepeatMode()" v-bind:class="{ active: state.repeatMode }">
          <md-tooltip md-direction="top">Replay</md-tooltip>
          <md-icon>replay</md-icon>
        </section>
      </div>
      <div class="player__right">
        <section class="player__progress">
          <section class="player__currentTime">{{state.currentTime | trackTime}}</section>
          <section class="player__progressLineWrapper" @mousemove="onProgressMouseMove" @mouseleave="onProgressMouseLeave" @click="seek()">
            <section class="player__progressLine">
              <section class="player__progressLine__active" v-bind:style="{ width: state.progress + '%' }"></section>
              <section class="player__progressLine__hover" v-bind:style="{ width: hoverProgress + '%' }"></section>
            </section>
          </section>
          <section class="player__endTime">{{ (state.activeTrack.duration) | trackTime}}</section>
        </section>
        <section class="player__volume">
          <section class="player__volume__inner">
            <section class="player__volume__icon" v-on:click="toggleVolume">
              <md-icon v-if="!isMute">volume_up</md-icon>
              <md-icon v-if="isMute">volume_mute</md-icon>
            </section>
            <player-volume-slider @volumeChanged="setVolume($event)" v-bind:volume="volume"></player-volume-slider>
          </section>
        </section>
      </div>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import PlayerVolumeSlider from './PlayerVolumeSlider';
import { State, Getter } from 'vuex-class';

@Component({
  components: {
    'player-volume-slider': PlayerVolumeSlider,
  },
})
export default class Player extends Vue {
  @State(state => state.audio)
  state;
  @Getter('volume') volume;
  hoverProgress = 0;

  onProgressMouseMove(event) {
    const { currentTarget, pageX } = event;
    const progress = (pageX - currentTarget.getBoundingClientRect().left) / currentTarget.offsetWidth;
    this.hoverProgress = Math.round(progress * 100);
  }

  onProgressMouseLeave() {
    this.hoverProgress = 0;
  }

  seek() {
    this.$store.dispatch('seek', this.hoverProgress);
  }

  setVolume(value) {
    this.$store.dispatch('setVolume', value / 100);
  }

  play() {
    if (this.state.isPlaying) {
      this.$store.dispatch('pause');
    } else {
      this.$store.dispatch('play', this.state.activeTrack);
    }
  }

  playNext() {
    this.$store.dispatch('playNext');
  }

  playPrev() {
    this.$store.dispatch('playPrev');
  }

  toggleRepeatMode() {
    this.$store.dispatch('toggleRepeatMode', !this.state.repeatMode);
  }

  toggleShuffleMode() {
    this.$store.dispatch('toggleShuffleMode', !this.state.shuffleMode);
  }

  toggleVolume() {
    this.$store.dispatch('toggleVolume');
  }

  get isMute() {
    return this.volume <= 0;
  }

  onClickArtist() {
    this.$route.push({
      name: 'play',
      params: { type: 'artist', id: this.state.activeTrack.artist.id },
    });
  }

  setBodyClass() {
    if (this.state.activeTrack) {
      const $container = document.querySelector('#shockwave');
      $container && $container.classList.add('playing');
    }
  }

  beforeUpdate() {
    this.setBodyClass();
  }

  mounted() {
    this.setBodyClass();
  }

  destroyed() {
    const $container = document.querySelector('#shockwave');
    $container && $container.classList.remove('playing');
  }
}
</script>

<style lang="stylus" scoped>
.player
  width 100%
  height 60px
  position fixed
  left 0
  right 0
  bottom 0
  display flex
  justify-content space-between
  transform translateZ(0)
  z-index 10
  user-select none

  &__inner
    width 100%
    max-width 1092px
    height 100%
    margin 0 auto
    display flex
    justify-content space-between
    align-items center
    background-color #1c212c
    box-shadow rgba(41,41,41,.2) 0px -1px 3px 0px, rgba(0,0,0,.14) 0px -1px 1px 0px, rgba(0,0,0,.12) 0px -2px 1px -1px

  &__left
    height 100%
    display flex

  &__artist
    min-width 300px
    max-width 400px
    display flex
    flex-direction row
    overflow hidden

    &__inner
      height 100%
      flex 0 0 60px
      position relative
    
    &__picture
      position absolute
      width 100%
      height 100%
      top 0
      left 0
      flex 0 0 60px
      background-size cover

    &__name
      color #565656
      font-size 12px
      font-weight bold
      cursor pointer
      transition color .08s ease-in-out
      &:hover
        color #8e98ae

    &__meta
      padding-left 12px
      display flex
      flex-direction column
      justify-content center

    &__title
      color #fff
      font-size 15px
      font-weight bold

  &__controls
    height 100%
    display flex
    align-items center

  &__control
    position relative
    margin 0 8px
    overflow hidden
    cursor pointer
    &.active
      md-icon
        color yellow
    &.playIcon
      margin 0 16px
      > i
        font-size 32px !important

  &__right
    display flex

  &__progress
    position relative
    width 350px
    margin-right 14px
    display flex
    align-items center

  &__currentTime
  &__endTime
    position absolute
    font-size 12px
    font-weight bold

  &__currentTime
    left 0
  &__endTime
    right 0

  &__progressLineWrapper
    position relative
    width calc(100% - 90px)
    height 12px
    left 45px
    display flex
    align-items center
    justify-content center
    cursor pointer

  &__progressLine
    width 100%
    height 2px
    background-color #333

    &__active
      position absolute
      width 40px
      height 2px
      background-color yellow

    &__hover
      position absolute
      width 40%
      height 2px
      background-color rgba(255,255,0,.5)

  &__volume
    width 54px
    height 100%
    padding-right 24px
    display flex
    justify-content center
    align-items center

    &__inner
      width 30px
      min-width 30px
      height 100%
      position relative
      display flex
      justify-content center
      align-items center
      cursor pointer

    .volumeSlider
      display none

    &:hover .volumeSlider
      display block

    .md-icon
      position relative
      z-index 100
</style>
